/* HEAD.h: header include file */
#include "treecon.h"
#include "pdl_gen.h"
/* $Id: deftbl.head,v 1.1 1992/06/20 19:04:11 kadhim Exp $ */
/* Type definitions for the property list module */

#include "deftbl.h"

/*
 * $Id: clp.head,v 1.2 1992/06/26 17:08:48 kadhim Exp $
 * Header file for CLP
 * Copyright, 1991, The Regents of the University of Colorado
 */

#include "clp.h"

/* $Id: option.head,v 2.7 1992/11/13 12:58:44 cogito Exp $ */
/* $Log: option.head,v $
Revision 2.7  1992/11/13  12:58:44  cogito
option reader now uses clp to access command line parameters

Revision 2.6  1991/11/08  14:52:39  cogito
include #include "err.h:

Revision 2.5  1991/11/08  12:14:12  cogito
*** empty log message ***

Revision 2.4  1991/09/12  12:18:49  mjung
'typedef int SYMB' removed. (Conflicts in Eli3.0)

Revision 2.3  1991/07/23  17:20:46  cogito
expand options: INCLUDING_FUNCTION replaced by INCLUDING ON / OFF
order options: new option ARRANGE FAST to cancel default ARRANGE AUTOMATICALLY
backend options: new option FREE_TREE (opposite of KEEP_TREE)

Revision 2.2  91/05/15  08:32:46  cogito
removed unused expand options

Revision 2.1  90/12/04  14:21:59  cogito
new version of option handler
 */

/***********************************************************************\
*	option.head							*
*	Header file for specification of the LIDO option handler	*
*									*
*	Written 11/13/90 - 07/23/91	by HaDeS			*
\***********************************************************************/

#ifndef _OPTION_HEAD_INCL
#define _OPTION_HEAD_INCL


#include <string.h>
#include "csm.h"
#include "option_enums.h"
#include "option_types.h"
#include "keywords.h"
#include "various.h"
#include "optlists.h"
#include "output.h"
#include "conflicts.h"
#include "err.h"

#define _VisitVarDecl() POSITION SaveCurPos;

#define _VisitEntry() \
{\
	SaveCurPos = curpos;\
	curpos = *COORDREF; \
}

#define _VisitExit() \
{\
	curpos = SaveCurPos;\
}

extern	char *exp_fname, *ord_fname, *opt_fname, *be_fname;


extern	ExpOption	ExpOptEnter1();
extern	ExpOption	ExpOptEnter2();
extern	ExpOption	ExpOptEnter3();

extern	OrdOption	OrdOptEnter1();
extern	OrdOption	OrdOptEnter2();
extern	OrdOption	OrdOptEnter3();
extern	OrdOption	OrdOptEnter4();
extern	OrdOption	OrdOptEnter5();
extern	OrdOption	OrdOptEnter6();
extern	OrdOption	OrdOptEnter7();

extern	OptOption	OptOptEnter1();
extern	OptOption	OptOptEnter2();
extern	OptOption	OptOptEnter3();

extern	BEOption	BEOptEnter1();
extern	BEOption	BEOptEnter2();

extern	OptCollect	InitOpts();
extern	OptCollect	JoinOpts();
extern	int		Mix_Options();

extern	OptCombin	TransferOpts1();
extern	OptCombin	TransferOpts2();
extern	OptCombin	TransferOpts3();
extern	OptCombin	TransferOpts4();

#endif

